// Window.cpp: implementation of the CWindow class.
//
//////////////////////////////////////////////////////////////////////
#include "Window.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CWindow::CWindow(LPCTSTR szClassName, WNDPROC WndProc, HINSTANCE hInst,
                 HICON hIcon, HICON hCursor, LPCTSTR lpszMenuName,
                 HBRUSH color, UINT style)
{
    WndClass.lpszClassName = szClassName;
    WndClass.lpfnWndProc = WndProc;
    WndClass.hInstance = hInst;
    WndClass.hIcon = hIcon;
    WndClass.hCursor = hCursor;
    WndClass.lpszMenuName = lpszMenuName;
    WndClass.hbrBackground = color;
    WndClass.style = style;
    WndClass.cbClsExtra = 0;
    WndClass.cbWndExtra = 0;

    RegisterClass(&WndClass);
}

CWindow::~CWindow()
{

}

HWND CWindow::Create(LPCTSTR lpWindowName, DWORD dwStyle,
                     int x, int y, int nWidth, int nHeight,
                       HMENU hMenu, LPVOID lpParam)
{
	this->nHeight = nHeight;
	this->nWidth = nWidth;
	hWnd = CreateWindow(WndClass.lpszClassName, lpWindowName, dwStyle,
		x, y, nWidth, nHeight, NULL, hMenu, WndClass.hInstance, lpParam);
	return hWnd;
}

int CWindow::GetFile(HWND hwnd, LPCTSTR fname, LPCTSTR filter)
{
	OPENFILENAME fn;

	memset(&fn, 0, sizeof(OPENFILENAME));
	fn.lStructSize = sizeof(tagOFNA);
	fn.hwndOwner = hwnd;
	fn.hInstance = WndClass.hInstance;
	fn.lpstrFilter = filter;
	fn.nFilterIndex = 1;
	#ifdef UNICODE
	  fn.lpstrFile = (LPWSTR)fname;
	#else
		fn.lpstrFile = (LPSTR)fname;
	#endif
	fn.nMaxFile = 256;
	fn.nMaxFileTitle = 1;
	fn.Flags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;

	return GetOpenFileName(&fn);
}

void CWindow::RePaint()
{
	RECT rect;

	GetClientRect(hWnd, &rect);
	InvalidateRect(hWnd, &rect, FALSE);
}
